## libthrust 1.4.0

=== debian/changelog ===
libthrust (1.4.0-1) unstable; urgency=low

  * Initial release.  (Closes: #628195)

 -- Andreas Beckmann <debian@abeckmann.de>  Sat, 28 May 2011 09:32:48 +0200
