## libthrust 1.5.0

=== debian/changelog ===
libthrust (1.5.0-1) unstable; urgency=low

  * New upstream release.
  * debian/copyright:
    - Update to dep5.mdwn?revision=202.
    - Update copyright entries for added/moved files.

 -- Andreas Beckmann <debian@abeckmann.de>  Fri, 02 Dec 2011 01:48:24 +0100
