=== debian/control ===
Source: libthrust
Section: contrib/libdevel
Priority: extra
Maintainer: Andreas Beckmann <debian@abeckmann.de>
Build-Depends: debhelper (>= 8)
Standards-Version: 3.9.2
Homepage: http://thrust.googlecode.com/
Vcs-Svn: svn://svn.debian.org/pkg-nvidia/packages/libthrust/trunk
Vcs-Browser: http://svn.debian.org/wsvn/pkg-nvidia/packages/libthrust/
DM-Upload-Allowed: yes

Package: libthrust-dev
Architecture: all
Depends: ${misc:Depends}
Recommends: nvidia-cuda-toolkit
Description: Thrust - C++ template library for CUDA
 Thrust is a CUDA library of parallel algorithms with an interface
 resembling the C++ Standard Template Library (STL). Thrust provides a
 flexible high-level interface for GPU programming by providing a rich
 collection of data parallel primitives such as scan, sort, and reduce.
 It then automatically selects an efficient implementation without
 requiring source modifications.
 .
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
