=== debian/watch ===
version=3

http://googlecode.debian.net/p/thrust/thrust-(\d+.*).zip
