## libthrust 1.5.1

=== debian/changelog ===
libthrust (1.5.1-1) unstable; urgency=low

  * New upstream release.
  * Set Maintainer to Debian NVIDIA Maintainers and move myself to Uploaders.

 -- Andreas Beckmann <debian@abeckmann.de>  Fri, 17 Feb 2012 12:05:55 +0100
