=== debian/control ===
--- 
+++ 
@@ -1,7 +1,9 @@
 Source: libthrust
 Section: contrib/libdevel
 Priority: extra
-Maintainer: Andreas Beckmann <debian@abeckmann.de>
+Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
+Uploaders:
+ Andreas Beckmann <debian@abeckmann.de>,
 Build-Depends: debhelper (>= 8)
 Standards-Version: 3.9.2
 Homepage: http://thrust.googlecode.com/
