## libthrust 1.6.0

=== debian/changelog ===
libthrust (1.6.0-1) unstable; urgency=low

  [ Andreas Beckmann ]
  * New upstream release.  (Closes: #671939)
  * New upstream hosting: http://thrust.github.com
  * Update watch file.
  * Move libthrust-dev from contrib to main as it gained support for OpenMP
    and TBB in addition to CUDA.  Update the description accordingly and
    lower the Recommends: nvidia-cuda-toolkit to a Suggests.
    (Closes: #671778)
  * Use the final copyright-format 1.0 URL.
  * Update to Standards-Version: 3.9.3.

  [ Mathieu Malaterre ]
  * Add get-orig-source in d/rules

 -- Andreas Beckmann <debian@abeckmann.de>  Wed, 09 May 2012 14:56:27 +0200
