=== debian/control ===
Source: libthrust
Section: libdevel
Priority: extra
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <debian@abeckmann.de>,
Build-Depends: debhelper (>= 8)
Standards-Version: 3.9.3
Homepage: http://thrust.github.com/
Vcs-Svn: svn://svn.debian.org/pkg-nvidia/packages/libthrust/trunk
Vcs-Browser: http://svn.debian.org/wsvn/pkg-nvidia/packages/libthrust/
DM-Upload-Allowed: yes

Package: libthrust-dev
Architecture: all
Depends: ${misc:Depends}
Suggests: nvidia-cuda-toolkit
Description: Thrust - Parallel Algorithms Library
 Thrust is a parallel algorithms library which resembles the C++ Standard
 Template Library (STL). Thrust's high-level interface greatly enhances
 programmer productivity while enabling performance portability between GPUs
 and multicore CPUs. Interoperability with established technologies (such as
 CUDA, TBB, and OpenMP) facilitates integration with existing software.
