=== debian/watch ===
version=3

https://github.com/thrust/thrust/downloads /downloads/thrust/thrust/thrust-(\d+.*).zip
