## libthrust 1.7.0

=== debian/changelog ===
libthrust (1.7.0-1) unstable; urgency=low

  * New upstream release.  (Closes: #715362)
  * Update watch file.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 10 Jul 2013 12:57:33 +0200

libthrust (1.6.0-2) unstable; urgency=low

  * Set Multi-Arch: allowed.
  * Use canonical Vcs-* URLs.
  * Bump Standards-Version to 3.9.4. No changes needed.
  * Switch to debhelper 9.
  * Update my email address and drop DMUA.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 06 May 2013 01:27:17 +0200
