=== debian/control ===
--- 
+++ 
@@ -3,16 +3,16 @@
 Priority: extra
 Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
 Uploaders:
- Andreas Beckmann <debian@abeckmann.de>,
-Build-Depends: debhelper (>= 8)
-Standards-Version: 3.9.3
+ Andreas Beckmann <anbe@debian.org>,
+Build-Depends: debhelper (>= 9)
+Standards-Version: 3.9.4
 Homepage: http://thrust.github.com/
-Vcs-Svn: svn://svn.debian.org/pkg-nvidia/packages/libthrust/trunk
-Vcs-Browser: http://svn.debian.org/wsvn/pkg-nvidia/packages/libthrust/
-DM-Upload-Allowed: yes
+Vcs-Svn: svn://anonscm.debian.org/pkg-nvidia/packages/libthrust/trunk
+Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-nvidia/packages/libthrust/
 
 Package: libthrust-dev
 Architecture: all
+Multi-Arch: allowed
 Depends: ${misc:Depends}
 Suggests: nvidia-cuda-toolkit
 Description: Thrust - Parallel Algorithms Library
