=== debian/watch ===
version=3

https://thrust.github.com/ .*/thrust-(\d+.*).zip
