## libthrust 1.8.1

=== debian/changelog ===
libthrust (1.8.1-1) unstable; urgency=medium

  * New upstream release.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 05 May 2015 04:25:40 +0200

libthrust (1.8.0-1) experimental; urgency=medium

  * New upstream release.  (Closes: #775260)
  * Packaging has been converted to GIT. Update Vcs-* URLs.
  * Bump Standards-Version to 3.9.6. No changes needed.
  * get-orig-source: Repack to .tar.xz.
  * Update debian/copyright.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 27 Jan 2015 03:46:04 +0100

libthrust (1.7.0-2) unstable; urgency=low

  * Set Multi-Arch: foreign.  (Closes: #735442)
  * Bump Standards-Version to 3.9.5. No changes needed.
  * Update d/copyright: upstream moved some files.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 27 Sep 2014 18:26:58 +0200
