=== debian/control ===
--- 
+++ 
@@ -5,14 +5,14 @@
 Uploaders:
  Andreas Beckmann <anbe@debian.org>,
 Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Homepage: http://thrust.github.com/
-Vcs-Svn: svn://anonscm.debian.org/pkg-nvidia/packages/libthrust/trunk
-Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-nvidia/packages/libthrust/
+Vcs-Git: git://anonscm.debian.org/pkg-nvidia/libthrust.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-nvidia/libthrust.git
 
 Package: libthrust-dev
 Architecture: all
-Multi-Arch: allowed
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Suggests: nvidia-cuda-toolkit
 Description: Thrust - Parallel Algorithms Library
