=== debian/rules ===
--- 
+++ 
@@ -7,4 +7,4 @@
 	dh $@ 
 
 get-orig-source:
-	uscan --verbose --force-download --rename --repack
+	uscan --verbose --force-download --rename --repack --compression xz
