## libthrust 1.8.2

=== debian/changelog ===
libthrust (1.8.2-1) unstable; urgency=medium

  * New upstream release.
  * Update Homepage and download URLs.
  * Switch to debhelper compat level 11.
  * Set Priority to optional.
  * Bump Standards-Version to 4.1.3.
  * Switch Vcs-* URLs to salsa.debian.org.
  * Set Rules-Requires-Root: no.
  * Add debian/upstream/metadata.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 26 Feb 2018 11:49:36 +0100
