=== debian/control ===
--- 
+++ 
@@ -1,14 +1,16 @@
 Source: libthrust
 Section: libdevel
-Priority: extra
+Priority: optional
 Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
 Uploaders:
  Andreas Beckmann <anbe@debian.org>,
-Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.6
-Homepage: http://thrust.github.com/
-Vcs-Git: git://anonscm.debian.org/pkg-nvidia/libthrust.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-nvidia/libthrust.git
+Build-Depends:
+ debhelper (>= 11~),
+Rules-Requires-Root: no
+Standards-Version: 4.1.3
+Homepage: https://github.com/thrust/thrust
+Vcs-Browser: https://salsa.debian.org/nvidia-team/libthrust
+Vcs-Git: https://salsa.debian.org/nvidia-team/libthrust.git
 
 Package: libthrust-dev
 Architecture: all
