=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 #export DH_VERBOSE=1
 
 %:
-	dh $@ 
+	dh $@
 
 get-orig-source:
 	uscan --verbose --force-download --rename --repack --compression xz
