=== debian/watch ===
version=3

https://github.com/thrust/thrust/releases .*/thrust-(\d+.*).zip
